<?php
  /*
  Plugin Name: Power Widgets Lite
  Version: 1.1.6
  Plugin URI: http://superplug.in
  Description: Power Widgets controls each widget area on your theme, creates custom widget areas (AKA custom sidebars) for specific pages, posts or categories, and manages them from one single location.
  Author: Super Plugin
  Author URI: http://superplug.in
  */

  /*
    Power Widgets controls each widget area on your theme, creates custom widget areas for specific pages, posts or categories, and manages them from one single location.
    Copyright (C) 2013  Planwize Ltd.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
//-------------------------------------------------end plugin header------------------------------------------

/*
 * Global constants
 */
/*$pluginsPhpFileRelativeURL = wp_make_link_relative(get_admin_url() . 'includes/plugin.php');
$wpPluginsPhpFileLoc = $_SERVER['DOCUMENT_ROOT'] . $pluginsPhpFileRelativeURL;*/
$wpPluginsPhpFileLoc = substr(ABSPATH, 0, -1);
$wpPluginsPhpFileLoc = $wpPluginsPhpFileLoc . '/wp-admin/includes/plugin.php';
$wpPluginsPhpFileLoc = preg_replace('~/+~', '/', $wpPluginsPhpFileLoc);

  require_once( $wpPluginsPhpFileLoc );

  // DO NOT ALLOW 2 PW VERSIONS TO WORK SIMULTANOUSLY
  if (is_plugin_active('PowerWidgets/PowerWidgets.php')) {
    $pluginsPageUrl = get_admin_url(NULL, 'plugins.php');
    wp_die ("Cannot activate Power Widgets Lite. First, return to <a href='".  $pluginsPageUrl ."'>Plugins</a> page and deactivate Power Widgets. Then, try to activate Power Widgets again");
  }

// absolute locations on file system
define('pw_file', __FILE__);
define('pw_dir', __DIR__);
define('pw_images', pw_dir . '/images' );
define('pw_php', pw_dir . '/php' );
define('pw_pages', pw_php . '/pages' );
define('pw_scripts', pw_php . '/scripts' );
define('pw_classes', pw_php . '/classes' );
define('pw_was', pw_classes . '/was' );
define('pw_repwas', pw_classes . '/repwas' );
define('pw_languages', pw_classes . '/languages' );

// urls
define ('pw_url', plugin_dir_url ( pw_file ) );
define ('pw_images_url', plugin_dir_url ( pw_file ) . 'images');
define ('pw_php_url', plugin_dir_url ( pw_file ) . 'php');
define ('pw_classes_url', pw_php_url . '/classes');
define ('pw_repwas_url', pw_classes_url . '/repwas');
define ('pw_was_url', pw_classes_url . '/was');



/*
 * Required scripts
 */
require_once ( pw_classes . '/PwList.php' );
require_once ( pw_classes . '/PwListOfUnique.php' );
require_once ( pw_classes . '/DbFunctionsLite.php' );
require_once ( pw_classes . '/GuiManager.php' );
require_once ( pw_classes . '/NotificationManager.php' );
require_once ( pw_classes . '/MenuBuilderPw.php' );
require_once ( pw_classes . '/ScriptManager.php' );
require_once ( pw_was . '/WaManager.php' );
require_once ( pw_repwas . '/RepwasManager.php' );
require_once ( pw_repwas . '/WaReplacer.php' );
require_once ( pw_languages . '/PwLanguages.php' );



// if class name not already exist
if(!class_exists('PowerWidgets')){
/*-------------------------------------------------------------------------------------------------------------*/
    /**
     * PowerWidgets is Main Plugin Object which provides the following services:
     *      (1) initializes supporting objects
     *      (2) handles activation
     *      (3) handles deactivation
     *      (4) builds, fills db tables and make them compatible with curren blog version number
     *
     * @author Jonathan
     */
    class PowerWidgets {
        private $je_sb_db_functions;
        private $gui_manager;
        private $je_sb_license_utilities;
        private $je_sb_wa_manager;
        private $je_sb_notif_manager;
        private $je_sb_menu_builder;
        private $je_sb_script_manager;
        private $je_sb_repwas_manager;
        private $je_sb_languages;

        const BLOG_VERSION = '9';

        /**
         * Constructor of PowerWidgets
         * @return PowerWidgets PowerWidgets object - main plugin object
         */
        function __construct() {
            $this->je_sb_languages = new PwLanguages();
            $this->je_sb_db_functions = new DbFunctionsLite();
            $this->je_sb_notif_manager = new NotificationManager();
            $this->gui_manager = new GuiManager ();
            $this->je_sb_wa_manager = new WaManager();
            $this->je_sb_script_manager = new ScriptManager();
            $this->je_sb_menu_builder = new MenuBuilderPw ();
            $this->je_sb_repwas_manager = new RepwasManager();
            $this->je_sb_replacer = new WaReplacer();
        }
    //-------------------------------------------------getters-------------------------------------------------

        function get_je_sb_db_functions(){
            return $this->je_sb_db_functions;
        }
        
        function get_gui_manager() {
            return $this->gui_manager;
        }

        function get_je_sb_license_utilities(){
            return $this->je_sb_license_utilities;
        }

        function get_je_sb_wa_manager() {
            return $this->je_sb_wa_manager;
        }

        function get_je_sb_notif_manager() {
            return $this->je_sb_notif_manager;
        }

        function get_je_sb_menu_builder() {
            return $this->je_sb_menu_builder;
        }

        function get_je_sb_script_manager() {
            return $this->je_sb_script_manager;
        }

        function get_je_sb_repwas_manager() {
            return $this->je_sb_repwas_manager;
        }
        
        function get_je_sb_replacer (){
            return $this->je_sb_replacer;
        }
        
        function get_je_languages () {
            return $this->je_sb_languages;
        }
        
        public static function getPwPluginVersion () {
            // initialize plugin version
            $plugin_header = get_plugin_data(pw_file);
            return $plugin_header['Version'];
        }
        

    //-------------------------------------------------end getters-------------------------------------------------    
    //-------------------------------------------------setters-------------------------------------------------      
        
        
        function set_je_sb_db_functions($value){
            $this->je_sb_db_functions = $value;
        }
        
        function set_gui_manager($value){
            $this->gui_manager = $value;
        }

        function set_je_sb_license_utilities($value) {
            $this->je_sb_license_utilities = $value;
        }

        function set_je_sb_wa_manager($value){
            $this->je_sb_wa_manager = $value;
        }

        function set_je_sb_notif_manager($value){
            $this->je_sb_notif_manager = $value;
        }

        function set_je_sb_menu_builder($value){
            $this->je_sb_menu_builder = $value;
        }

        function set_je_sb_script_manager($value){
            $this->je_sb_script_manager = $value;
        }

        function set_je_sb_repwas_manager($value) {
            $this->je_sb_repwas_manager = $value;
        }
        
        function set_je_sb_replacer ($value){
            $this->je_sb_replacer = $value;
        }
        
        function set_je_sb_languages ($value){
            $this->je_sb_languages = $value;
        }

    //-------------------------------------------------end setters-------------------------------------

    //-----------------------------------------------------------------------------------------------------
        /**
         * handles plugin activation, including:
         *      (1) wordpress version validation
         *      (2) updating db tables to be compatible with current blog version number 
         *              and fill them with necessary initialization data
         * @param none
         * @return void
         */
        function je_sb_handle_plugin_activation() {
                define ('OLDEST_VERSION', '3.1');
                //validate wordpress version is not older than 3.1
                if (version_compare( get_bloginfo( 'version' ), OLDEST_VERSION, '<' ) ){
                    die("This Plugin requires WordPress version " . OLDEST_VERSION . " or higher");
                }
                
                $curr_blog_ver = get_option('pw_blog_version', 0);
                
                // current blog version is a pro version
                $valid_built = DbFunctionsLite::create_curr_blog_pw_tables($curr_blog_ver, intval(self::BLOG_VERSION));

                if ($valid_built){
                    //TODO: update only if needed
                    update_option('pw_blog_version', self::BLOG_VERSION);
                }

        }   // end function je_sb_handle_plugin_activation

    //-----------------------------------------------------------------------------------------------------
        /**
         * handles plugin deactivation, including:
         * @param none
         * @return void
         */
        function je_sb_handle_plugin_deactivation() {
        }

    //-----------------------------------------------------------------------------------------------------
        /**
         * make db tables compatible with current blog version.
         * and fill them with necessary initialization data
         * @param none
         * @return void
         */
        function fill_db_tables() {
            $curr_blog_ver = get_option('pw_blog_version', 0);
            $curr_blog_ver = intval(substr($curr_blog_ver, 1));
            $desired_blog_ver = intval(substr(self::BLOG_VERSION, 1));
            $valid_built = DbFunctionsLite::create_curr_blog_pw_tables($curr_blog_ver, $desired_blog_ver);

            // update blog version if the build was successful
            if ($valid_built){
                //TODO: update only if needed
                update_option('pw_blog_version', self::BLOG_VERSION);
            }
        }

    }//end class power_widgets
}//end if class exists

//--------------------------------------main part-------------------------------------------

    //--------------------------------------------------actions loading --------------------------------------------------

    //site_builder object creation
    $GLOBALS['mainPwObj'] = new PowerWidgets();
    
    // fill db tables if needed
    add_action( 'plugins_loaded', array ($GLOBALS['mainPwObj'], 'fill_db_tables') );
    
    //plugin activation
    register_activation_hook(__FILE__, array($GLOBALS['mainPwObj'], 'je_sb_handle_plugin_activation'));
    
    //plugin deactivation
    register_deactivation_hook(__FILE__, array($GLOBALS['mainPwObj'], 'je_sb_handle_plugin_deactivation'));

//--------------------------------------------------end actions loading --------------------------------------------------

//--------------------------------------------------end of main part-------------------------------------------------
?>