jQuery.extend(jQuery.fn.datagrid.defaults.editors, {
    combobox: {
            init: function(container, options){
                    var combo = jQuery('<input type="text">').appendTo(container);
                    //combo.combobox(options || {});
                    combo[0].options = options || {};
                    combo.bind('focus', function(){
                            if (!jQuery(this).data('combobox')){
                                    jQuery(this).combobox(this.options);
                            }
                    });
                    return combo;
            },
            destroy: function(target){
                    jQuery(target).data('combobox') ? jQuery(target).combobox('destroy') : jQuery(target).remove();
            },
            getValue: function(target){
                    return jQuery(target).data('combobox') ? jQuery(target).combobox('getValue') : jQuery(target).val();
            },
            setValue: function(target, value){
                    jQuery(target).data('combobox') ? jQuery(target).combobox('setValue', value) : jQuery(target).val(value);
            },
            resize: function(target, width){
                    jQuery(target).data('combobox') ? jQuery(target).combobox('resize', width) : jQuery(target)._outerWidth(width);
            }
    }
});

jQuery.extend(jQuery.fn.validatebox.defaults.rules, {

    english : {
        validator : function(value) { 
            return /^[a-z0-9]+[a-z0-9- ]*$/i.test(value); 
        }, 
        message : 'pattern should start with a letter or a number,and optionally followed by letters, numbers, spaces or hyphens' 
    }
});
	
jQuery(function(){
                
    var admin_url = jQuery('#admin-url').html();
    var current_theme = jQuery('#current-theme').html();
    var rep_type = jQuery('#rep-type').html();
    var edited_post = jQuery('#edited-post').html();

    var table_height = 400; // are we in a page/post edit page? if so, table is short (160 px)
    // if edited post is a number we are in a post/page edit page
    if ( !isNaN(parseInt(edited_post)) ){
         table_height = 160;
    }

    jQuery('#dg').edatagrid({
    width: 'auto',
    height: table_height,
                                scrollbarSize:0,
    url: admin_url +  "admin-ajax.php?action=get_repwas_table" + "&" + current_theme + "&" + rep_type + "&edited_post=" + edited_post,
    updateUrl: admin_url +  "admin-ajax.php?action=update_repwas_table_row" + "&" + current_theme + "&" + rep_type
    });

    // adjust the columns width if needed
	if (jQuery('#dg').length){
		var view2 = jQuery('#dg').datagrid('getPanel').find('div.datagrid-view2');
		var table = view2.find('table.datagrid-htable');
		if (table.width() < view2.width() - 20){
		var cc = jQuery('#dg').datagrid('getColumnFields',false);
		for(var i=0; i<cc.length; i++){
				var col = jQuery('#dg').datagrid('getColumnOption',cc[i]);
				col.auto = false;
		}
		jQuery('#dg').datagrid('options').fitColumns = true;
		jQuery('#dg').datagrid('fitColumns');
		//jQuery('#dg').datagrid('options').fitColumns = false;
		}
	}
});


function formatReplaceableElement(value,row){
	var site_url = jQuery('#site-url').html();
	return '<a href="' + site_url + '?p=' + row.replaceable_element_id + '">'+value+'</a>';
}
function doSearch(){  
    jQuery('#dg').datagrid('load',{
        replaceable_element: jQuery('#replaceable_element').val()
    });
}  
