<?php

require_once('DbFunctionsLite.php');

/**
 * GuiManager provides functions  that create power widgets GUI
 *
 * @author Jonathan
 */
class GuiManager { 
    

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * GuiManager constructor
     */
        function __construct() {
            // add gui components
            add_action('init', array ($this, 'addGuiComponents'));
        }   // end GuiManager constructor
        
//-------------------------------------------------getters-------------------------------------------------
    
//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------     
//-------------------------------------------------end setters-------------------------------------
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        
        /**
         * 
         */
        public function addGuiComponents() {
            // add thickbox (For opening windows)
           add_thickbox();
        }
        
        /**
         * does basic page output which includes outputing a title
         * @param string $title 
         *      plugin page title
         * @return void
         */
        function je_sb_do_page_output($title) {
            if (!current_user_can('manage_options'))  {
                wp_die( __('You do not have sufficient permissions to access this page.') );
            }

            echo '<div class="wrap">';
            echo '<h1>'.$title.'</h1>';
            echo '</div>';
        }
    
 
    
/* -------------------------------------------------------------Getting Started-------------------------------------------------------*/
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * outputs "Getting Started" page content, including both (1) license validation messages and (2) html 
     * interface, usingje_sb_output_license_status_msgs() and je_sb_print_manage_getting_started_interface 
     * respectively
     *@param none
     * @return void
     */
    function je_sb_output_site_builder_content () {
            
        // build getting started gui
         $getting_started_file = pw_pages . '/getting_started.php';
            require_once ($getting_started_file);
            //echoGettingStarted();
    }

/* -----------------------------------------------------------End Getting Started-------------------------------------------------------*/    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * outputs theme's custwa array into select box
     * @static
     * @param array $theme_custwa_result Description
     *      array contatining all theme custwas
     * @param string $select_box_name 
     *      the select box name attribute
     * @return string 
     *      string containing select box html instructions
     */
    static function je_sb_output_cs_to_select_box($theme_custwa_result, $select_box_name){
            $select_box = "<select name='" . $select_box_name. "' style='width: 200px'>";
            if ($theme_custwa_result){
                foreach ($theme_custwa_result as $custwa) {
                    $select_box .= "<option value='" . $custwa->custwa_name . "'>" .
                        $custwa->custwa_name . "</option>";
                }
            }
            $select_box.= "</select>";// Closing of select box

            return $select_box;
    }
    
/* -------------------------------------------------------------------------------------------------------------------------------------------------------*/
    /** starts a new form by echoing the opening tag with the parameters provided
     * @param string $id
     *      form id
     * @param string $action
     *      form action
     * @param string $method
     *      form method
     * @return void
     */
    public function startForm($id = NULL, $action = NULL, $method = NULL)   {
        // name
        if (!$id)   { $id = "";   }
        else {  $id= "id = \"$id\"";}
        
        // action
        $action = "action = \"" . $action . "\"";

        
        // method
        if (!$method)   { $method = "";   }
        else {  $method = "method = \"$method\"";   }
        
        echo "<form $id $action $method>";
    }   // end function startForm
/* -------------------------------------------------------------------------------------------------------------------------------------------------------*/
    /** ends a form
     * @param none
     * @return void
     */
    public function endForm()   {
        echo "</form>";
    }   // end function endForm
    
    public function echoCheckbox($id, $name, $value) {
        echo "<input type=\"checkbox\" id=\"$id\" name=\"$name\" value=\"$value\">$value";
?>
<?php
    }   // end function echoCheckbox
    
    /* ---------------------------------------------------------End Gui Manager------------------------------------------------*/
    
}

?>