<?php

if(!class_exists('MenuBuilderPw')){
    
/**
 * MenuBuilderPw builds power widgets menus on wordpress dashboard
 * 
 * @author Jonathan
 */
    class MenuBuilderPw {   
    

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * MenuBuilderPw constructor
     * @param none
     * @return MenuBuilderPw a new MenuBuilderPw
     */
        function __construct() {
            /* actions */
            // add plugin menus
            add_action( 'admin_menu', array ($this, 'je_sb_add_plugin_menus') );
        }   // end MenuBuilderPw constructor
        
//-------------------------------------------------getters-------------------------------------------------
    
//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------  
    
//-------------------------------------------------end setters-------------------------------------
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * adds plugin menus
         * @param none
         * @return void
         */
         function je_sb_add_plugin_menus() {
                 // gui manager objects
                 $rgm = $GLOBALS['mainPwObj']->get_je_sb_repwas_manager()->get_repwasGuiManager();
                 $wagm = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_wasGuiManager();
                 
                 
                 // create a script manager object:
                 $scr_mngr = $GLOBALS['mainPwObj']->get_je_sb_script_manager();
                 $was_scr_mngr = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_wasScriptManager();
                 
                 // welcome page
                 $page = add_menu_page('site_builder Options', __('Power Widgets', 'PWL'), 'manage_options', 'site_builder-slug-name', array($rgm, 'je_sb_output_site_builder_content' ));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'getting_started_submenu_style' ));
                
                
                 //getting started
                 $page = add_submenu_page('site_builder-slug-name', 'Getting Started', __('Getting Started', 'PWL'), 'manage_options', 'site_builder-slug-name', 
                     array($rgm, 'je_sb_output_site_builder_content' ));
                 
                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'getting_started_submenu_style' ));

                 //Manage Widget Areas
                 $page = add_submenu_page('site_builder-slug-name', 'Manage Widget Areas', __('Manage Widget Areas', 'PWL'), 'manage_options', 'CS-slug-name', 
                     array($wagm, 'outputManageWa'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($was_scr_mngr, 'addWasStyle' ));
                
                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($was_scr_mngr, 'addWasScripts' ));


                //Manage Widget Areas in Pages
                 $page = add_submenu_page('site_builder-slug-name', 'Pages', __('Pages', 'PWL'), 'manage_options', 'CScontrol-slug-name', 
                     array($rgm, 'outputPagesContent'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'custwa_control_submenu_style' ));

                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($scr_mngr, 'custwa_control_submenu_scripts' ));

                //Manage Widget Areas in Posts
                $page = add_submenu_page('site_builder-slug-name', 'Posts', __('Posts', 'PWL'), 'manage_options', 'CScontrolposts-slug-name', 
                     array($rgm, 'outputPostsContent'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'custwa_control_submenu_style' ));

                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($scr_mngr, 'custwa_control_submenu_scripts' ));

                //Manage Widget Area in Categories
                $page = add_submenu_page('site_builder-slug-name', 'Categories', __('Categories', 'PWL'), 'manage_options', 'CScontrolcategories-slug-name', 
                     array($rgm, 'outputCategoriesContent'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'custwa_control_submenu_style' ));

                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($scr_mngr, 'custwa_control_submenu_scripts' ));

                //Manage Widget Area in tags
                $page = add_submenu_page('site_builder-slug-name', 'Tags', __('Tags', 'PWL'), 'manage_options', 'CScontroltags-slug-name', 
                     array($rgm, 'outputTagsContent'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'custwa_control_submenu_style' ));

                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($scr_mngr, 'custwa_control_submenu_scripts' ));

                //Manage Widget Area in Page Templates
                $page = add_submenu_page('site_builder-slug-name', 'Page Templates', __('Page Templates', 'PWL'), 'manage_options', 'CScontrolpagetemplates-slug-name', 
                     array($rgm, 'outputPageTemplatesContent'));

                 /* Using registered $page handle to hook stylesheet loading */
                add_action( 'admin_print_styles-' . $page, array ($scr_mngr, 'custwa_control_submenu_style' ));

                 /* Using registered $page handle to hook script load */
                add_action( 'admin_print_scripts-' . $page, array ($scr_mngr, 'custwa_control_submenu_scripts' ));

         } // end function je_sb_add_plugin_menus
    }   //end class MenuBuilderPw
}   // end if class MenuBuilderPw doesn't exist

?>
