<?php

if(!class_exists('NotificationManager')){
    
    /**
     * NotificationManager offers manages PW notifications and provides the following services
     *      1) add a good notification
     *      2) add an error notification
     *      3) get good and error notifications
     *      3) output notifications
     *
     * @author Jonathan
     */
    class NotificationManager {
        
        static private $je_sb_errors;
        static private $je_sb_good_notifiactions;
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * Constructor of NotificationManager 
         */
        public function __construct() {
            NotificationManager::$je_sb_errors = array();
            NotificationManager::$je_sb_good_notifiactions = array();
            
            /* actions */
            // print errors and good notifications
            add_action('admin_notices', array($this, 'show_powerwidgets_messages')); 
        } // end NotificationManager Constructor
            
/* ---------------------------------------getters---------------------------------------------------------------------------------------*/
        static public function get_je_sb_good_notifiactions(){
            return NotificationManager::$je_sb_good_notifiactions;
        }
        
        static public function get_je_sb_errors(){
            return NotificationManager::$je_sb_errors;
        }
/* ---------------------------------------end getters----------------------------------------------------------------------------------*/
/* ---------------------------------------setters----------------------------------------------------------------------------------------*/
        static public function set_je_sb_good_notifiactions($value){
            NotificationManager::$je_sb_good_notifiactions = $value;
        }
        
        static public function set_je_sb_errors($value){
            NotificationManager::$je_sb_errors = $value;
        }
        
/* ---------------------------------------end setters----------------------------------------------------------------------------------*/

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
            * adds a good notification
            * @param string $good_notification Description:
            *      containing good notification text
            * @return void
         */
        static public function je_sb_add_good_notification($good_notification){
            NotificationManager::$je_sb_good_notifiactions[] = $good_notification;
        }
        
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
            *  adds a new element to the errors array class member
            * @param WP_Error $error
            *      a wordpress error object
            * @return void
         */
        static public function je_sb_add_error($error) {
            NotificationManager::$je_sb_errors[count(NotificationManager::get_je_sb_errors())] = $error;
        }
        
 /* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * outputs power widgets messages
         * @param none
         * @return void
         */
        function show_powerwidgets_messages(){
                // show all the errors
                $all_errors = NotificationManager::get_je_sb_errors();
                if ($all_errors){
                    foreach ($all_errors as $error) {
                        echo '<div id="error_message" class="error">' . $error->get_error_message() . '</div>';
                    }
                }

                //show all good notifications
                $all_good_notifications = NotificationManager::get_je_sb_good_notifiactions();
                if ($all_good_notifications){
                    foreach ($all_good_notifications as $good_not) {
                        echo '<div id="new_custwa_created" class="updated">' . $good_not . '</div>';
                    }
                }
        }        
    }   // end class NotificationManager
}   // end if class exists

?>
