<?php

if(!class_exists('ScriptManager')){
    
/**
 * ScriptManager is in charge of script handling and provides the following services:
 *  (1) scripts/styles registration
 *  (2) different functions enqueuing scripts/styles regarding a required page
 *
 * @author Jonathan
 */
    class ScriptManager {

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * Constructor of ScriptManager
         */
        function __construct() {
            // add stylesheet and js scripts
            add_action( 'admin_init', array($this, 'register_plugin_scripts') );
        }   // end ScriptManager constructor
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * registers css style files and js javascript scripts
         * @param none
         * @return void
         */
        function register_plugin_scripts() {
            // get plugin version
            $plugin_version = PowerWidgets::getPwPluginVersion();
            
            /* Register our stylesheet */
            wp_register_style( 'getting_started_PluginStylesheet', plugins_url('css/getting_started_style.css', pw_file, array(), $plugin_version) );
            wp_register_style( 'easyui_css', pw_url .'js/jquery-easyui-1.3.4/themes/default/easyui.css', array(), $plugin_version );
            wp_register_style( 'easyui_rtl_css', pw_url .'js/jquery-easyui-1.3.4/easyui-rtl.css', array(), $plugin_version );
            wp_register_style( 'icon_css', pw_url . 'js/jquery-easyui-1.3.4/themes/icon.css', array(), $plugin_version );


            /* Register our js */
            wp_register_script( 'jquery-easyui-script', pw_url . 'js/jquery-easyui-1.3.4/jquery.easyui.min.js', array(), $plugin_version);
            wp_register_script( 'jquery-easyui-rtl-script', pw_url . 'js/jquery-easyui-1.3.4/easyui-rtl.js', array(), $plugin_version);
            wp_register_script( 'jquery-edatagrid-script', pw_url . 'js/jquery-easyui-1.3.4/jquery.edatagrid.js', array(), $plugin_version);
            wp_register_script( 'jquery-controlTable-script', pw_url . 'js/controlTable.js', array(), $plugin_version);
        }
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enques registered css style files to the "Getting Started" submenu
         * @param none
         * @return void
         */
         function getting_started_submenu_style() {
                 // enqueue style
                //wp_enqueue_style( 'getting_started_PluginStylesheet');
                wp_enqueue_style('easyui_css');
         }

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enques registered css style files to the "Manage Widget Areas" submenu
         * @param none
         * @return void
         */
         function add_remove_custwa_submenu_style() {
         }

/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enqueus registered css style files to all replacements control submenus:
         * ("Pages", "Posts", "Categories", "Tags", "Page Templates")
         * @param none
         * @return void
         */
         function custwa_control_submenu_style() {
                 wp_enqueue_style('easyui_css');
                 
                $direction = get_option('pw_dir', NULL);
                if ($direction === 'rtl'){
                     wp_enqueue_style( 'easyui_rtl_css' );
                }
                wp_enqueue_style( 'icon_css' );
         }

         
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enques registered .js script files to all replacements control submenus:
         * ("Pages", "Posts", "Categories", "Tags", "Page Templates")
         * @param none
         * @return void
         */
         function custwa_control_submenu_scripts() {
                 wp_enqueue_script('jquery-easyui-script');
                 $direction = get_option('pw_dir', NULL);
                 if ($direction === 'rtl'){
                     wp_enqueue_script( 'jquery-easyui-rtl-script');
                 }
                 wp_enqueue_script( 'jquery-edatagrid-script');
                 wp_enqueue_script( 'jquery-controlTable-script');
         }
         
    }   // end class ScriptManager
}   // end if class not exists
?>
