<?php

/**
 * ThemeReplaceableRepwas is a list of all current theme replacements widget areas of a given repalceable.
 * Each element of the List is of Repwa type.
 *
 * @author Jonathan
 */
class RepwaList extends PwListOfUnique{
    
    public function __construct() {
        parent::__construct();
    }


//-------------------------------------------------getters-------------------------------------------------


    
//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------  


    
//-------------------------------------------------end setters-------------------------------------
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * transfers db repwas to a RepwaList object
         * @param array $dbRepwas
         *      repwas in a db result set format
         * @param WP_Theme $theme
         *      repwas theme
         * @param array $dbKeys
         *      The name of the properties of the db which are equivalent to:
         *      repwa id, defwa id, custwa name, theme, element id and element type
         * @return RepwaList
         *      the tranformed RepwaList object
         */
        static public function dbRepwasToRepwaList($dbRepwas , $dbKeys, $defwas, $custwas ) {
            /* TODO input validation on dbKeys */
            list ($repwa_id, $defwa_id, $custwa_name, $theme, $categoryId, $categoryType) = $dbKeys;
            $repwaList = new RepwaList();
            
            // verify defwas and custwas are valid
            if (!self::isValidDefwasAndCustwas($defwas, $custwas)) {
                $error = new WP_Error('dbRepwasToRepwaList_invalidDefwaOrCustwa', 
                        __("dbRepwasToRepwaList: invalid default widget area or custom widget area was provided"));
                $GLOBALS['mainPwObj']->get_je_sb_notif_manager()->je_sb_add_error($error);
                
                return $repwaList;
            }
            
            // go through each db repwa
            foreach ($dbRepwas as $dbRepwa) {
                $categoryRepwa = new Repwa ( 
                    $dbRepwa->$repwa_id, 
                    //$GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_defwas()->getById($dbRepwa->$defwa_id), 
                    $defwas->getById($dbRepwa->$defwa_id), 
                    //$GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_custwas()->getById($dbRepwa->$custwa_name), 
                    $custwas->getById($dbRepwa->$custwa_name), 
                    $dbRepwa->$theme, 
                    $dbRepwa->$categoryId, 
                    $dbRepwa->$categoryType
                );
                // add repwa to PwCategory repwa member
                $repwaList->add($categoryRepwa);
            }
            return $repwaList;
        }   // end of dbRepwasToRepwaList    
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * validates defwas and custwas are indeed DefwaList and CustwaList.
         * @param array $dbRepwas
         *      repwas in a db result set format
         * @param WP_Theme $theme
         *      repwas theme
         * @param array $dbKeys
         *      The name of the properties of the db which are equivalent to:
         *      repwa id, defwa id, custwa name, theme, element id and element type
         * @return RepwaList
         *      the tranformed RepwaList object
         */
        private static function isValidDefwasAndCustwas ($defwas, $custwas){
            if (!($defwas instanceof DefwaList)|| !($custwas instanceof CustwaList))   {
                return FALSE;
            }
            return TRUE;
        }
}

?>
