<?php

require_once(pw_edit_mode . '/gui/RepwasEditModeGuiManager.php');

/**
 * InPageEditMode adds editing replacements capability from page/post edit mode
 *
 * @author Jonathan
 */
class RepwasEditMode {
    
    private $repwasEditModeGuiManager;
    
    /**
     * Constructor of InPageEditMode
     */
    public function __construct() {
        $this->repwasEditModeGuiManager = new RepwasEditModeGuiManager();
        
        //hook into page
        add_action ( 'add_meta_boxes', array ($this, 'je_sb_add_post_metabox') );

    }   // end of InPageEditMode constructor

/* ---------------------------------------getters---------------------------------------------------------------------------------------*/
        function get_repwasEditModeGuiManager (){
            return $this->repwasEditModeGuiManager;
        }
        
/* ---------------------------------------end getters----------------------------------------------------------------------------------*/
/* ---------------------------------------setters----------------------------------------------------------------------------------------*/
        function set_repwasEditModeGuiManager ($value){
            $this->repwasEditModeGuiManager = $value;
        }
        
        
/* ---------------------------------------end setters----------------------------------------------------------------------------------*/
    
    /**
     * add metaboxe div to pages and posts
     * @param none
     * @return void
     */
    function je_sb_add_post_metabox() {
        //add scripts and styles
        $sm = $GLOBALS['mainPwObj']->get_je_sb_script_manager();
        $sm->custwa_control_submenu_scripts();
        $sm->custwa_control_submenu_style();
       
        // add metabox for posts and pages
        $remgm = $this->get_repwasEditModeGuiManager();
        add_meta_box('pw_post_reps_div', __('Power Widgets Post Replacement'), array ($remgm, 'je_sb_print_post_metabox_interface'), 'post', 'normal', 'core');
        add_meta_box('pw_post_reps_div', __('Power Widgets Post Replacement'), array ($remgm, 'je_sb_print_page_metabox_interface'), 'page', 'normal', 'core');
    }
}

?>
