<?php

/**
 * RepwasEditModeGuiManager includes all gui components used for the repwas edit mode feature
 * and an output function for printing a replacements control interface withing the page/post
 * edit mode page
 *
 * @author Jonathan
 */
class RepwasEditModeGuiManager extends RepwasGuiManager {
    
    /**
     * Constructor of RepwasEditModeGuiManager
     */
    public function __construct() {
        parent::__construct();
    }
    
/* ----------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * prints post metabox interface using je_sb_print_CSControl_interface
     * @param string $edited_post 
     *      relevant edited post (which will be the only record in the replacements control table)
     * @return void
     */
    function je_sb_print_post_metabox_interface($edited_post) {
        $rep_type = 'post';
        $edited_post_id = intval($edited_post->ID);
        $this->je_sb_print_CSControl_interface($rep_type, $edited_post_id);
    }   // end function je_sb_print_post_metabox_interface
    
/* ----------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * prints page metabox interface using je_sb_print_CSControl_interface
     * @param string $edited_page 
     *      relevant edited page (which will be the only record in the replacements control table)
     * @return void
     */
    function je_sb_print_page_metabox_interface($edited_page) {
        $rep_type = 'page';
        $edited_page_id = intval($edited_page->ID);
        $this->je_sb_print_CSControl_interface($rep_type, $edited_page_id);
    }   // end function je_sb_print_page_metabox_interface
}

?>
