<?php

require (pw_classes . '/PwList.php');
/**
 * CustwasDropdown represents a custom widget areas dropdown
 *
 * @author Jonathan
 */
class CustwasDropdown {
    private $logicCustwasDropdown;  //a CustwasList object represents the data in the custwas list dropdown
    private $jeasyuiCustwasDropdown;   // the visual custwas dropdown component; 
    
    /**
     * Constructor of CustwasDropdown
     * @param CustwaList $logicCustwasDropdown
     * @return CustwasDropdown
     */
    public function __construct($logicCustwasDropdown) {
        $this->logicCustwasDropdown = $logicCustwasDropdown;
        $this->jeasyuiCustwasDropdown = $this->jeasyuiCustwasDdFromLogicalCustwas($this->logicCustwasDropdown);
    }
    
/* ---------------------------------------getters---------------------------------------------------------------------------------------*/
    function get_logicCustwasDropdown () {
        return $this->logicCustwasDropdown;
    }

/* ---------------------------------------end getters----------------------------------------------------------------------------------*/

/* ---------------------------------------setters----------------------------------------------------------------------------------------*/
    function set_logicCustwasDropdown ($value){
        $this->logicCustwasDropdown = $value;
    }
    
/* ---------------------------------------end setters----------------------------------------------------------------------------------*/
    
    private function jeasyuiCustwasDdFromLogicalCustwas ($logicCustwasDropdown) {
        // check permissions
            $jeasyuiCustwasDd = array();

            //initialize first custwa object to be written which has an empty value
            $jeasyuiCustwaObj = new stdClass;
            $jeasyuiCustwaObj->id = '';
            $jeasyuiCustwaObj->text = '';
            $jeasyuiCustwasDd[] = $jeasyuiCustwaObj;


            // go through all custwas
            foreach ($logicCustwasDropdown->getList() as $custwa_obj) {
                
                $custwa_name = $custwa_obj->get_name(); // get current custwa

                $jeasyuiCustwaObj = new stdClass;   //initialize object to be written
                
                $jeasyuiCustwaObj->id = $custwa_name;   //update custwa element id in obj to be written
                $jeasyuiCustwaObj->text = $custwa_name; //update custwa element name in obj to be written
                
                $jeasyuiCustwasDd[] = $jeasyuiCustwaObj;    //add custwa to the dropdown custwas
            }

            return $jeasyuiCustwasDd;
    }   // end function jeasyuiCustwasDdFromLogicalCustwasDd
    
    /**
     * Echos custwas dropdown gui component
     * @param none
     * @return void
     */
    public function __toString() {
            return json_encode($this->jeasyuiCustwasDropdown);
    }   // end function __toString
}

?>
