<?php

/**
 * LogicRepwasTableHeader holds a replacements control table header fields
 *
 * @author Jonathan
 */
class LogicRepwasTableHeader {
    private $repType;   // replaceable type
    private $defwas;    // table defwas
    private $theme;     // current theme
    private $searchedText;   // the searched text in the table. NULL if no search was made
    private $editedElement;  // post or page id in case we're in post/edit mode. NULL If we're not in that mode.
    
    
    /**
     * Constructor of LogicRepwasTableHeader
     * @param type $repType
     *      replaceable table type
     * @param type $defwas
     *      current theme's default widget areas
     */
    public function __construct($repType, $defwas, $searchedText, $editedElement) {
        $this->repType = $repType;
        $this->defwas = $defwas;
        $this->theme = wp_get_theme();
        $this->searchedText = $searchedText;
        $this->editedElement = $editedElement;
    }   // End of Constructor
    
/* ---------------------------------------getters---------------------------------------------------------------------------------------*/
    public function getRepType () {
        return $this->repType;
    }
    
    public function getDefwas () {
        return $this->defwas;
    }
    
    public function getTheme () {
        return $this->theme;
    }
    
    public function getSearchedText () {
        return $this->searchedText;
    }
    
    public function getEditedElement () {
        return $this->editedElement;
    }
    
/* ---------------------------------------end getters----------------------------------------------------------------------------------*/
/* ---------------------------------------setters----------------------------------------------------------------------------------------*/
    public function setRepType ($value) {
        $this->repType = $value;
    }
    
    public function setDefwas ($value) {
        $this->defwas = $value;
    }
    
    public function setTheme ($value) {
        $this->theme = $value;
    }
    
    public function setEditedElement ($value) {
        $this->editedElement = $value;
    }
        
/* ---------------------------------------end setters----------------------------------------------------------------------------------*/
    
}   // end class LogicRepwasTableHeader

?>
