<?php

require_once('WidgetAreaPw.php');
// if Custwa class does not exist
if(!class_exists('Custwa')){
    
    /**
     * Custwa represents a power custom widgets widget area object
     *
     * @author Jonathan
     */
    class Custwa extends WidgetAreaPw{
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * Custwa constructor - builds a new Custwa object
     * @param string $id 
     *      custwa id
     * @param string $name 
     *      custwa name
     * @param $description
     *      custwa description
     * @param $theme
     *      custwa theme
     * @param $class
     *      custwa class
     * @param $bewidget
     *      custwa before widget
     * @param $afwidget
     *      custwa after widget
     * @param $betitle
     *      custwa before title
     * @param $aftitle
     *      custwa after title
     * 
     * @Return Custwa
     *      new Custwa object - if custwa was successfully created.
     *      new Custwa object with all members set to NULL - if failed
     */
        public function __construct($id, $name, $description, $theme, $class = '', $bewidget = '', $afwidget= '', $betitle = '', $aftitle = '') {
            // Precondition: name is valid
            parent::__construct($id, $name, $description, $theme, $class, $bewidget, $afwidget, $betitle, $aftitle);
        }
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * Defwa Constructor - builds a new Custwa object with a given widget area
         * @param WidgetAreaPw $wa
         * @return Custwa
         */
        public static function __constructWithWa ($wa) {
            parent::__construct(
                    $wa->get_id(), 
                    $wa->get_name(), 
                    $wa->get_description(), 
                    $wa->get_theme(), 
                    $wa->get_class(), 
                    $wa->get_bewidget(), 
                    $wa->get_afwidget(), 
                    $wa->get_betitle(), 
                    $wa->get_aftitle()
                );
        } // end function __constructWithWa
    }
}

?>
