<?php

require_once ('WidgetAreaList.php');
if(!class_exists('CustwaList')){
    
    /**
     * CustwaList implements a list of Custwa objects
     *
     * @author Jonathan
     */
    class CustwaList extends WidgetAreaList{
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * CustwaList constructor - builds a new CustwaList object contain empty list of defwas
     * @Return CustwaList new empty CustwaList 
     */
        public function __construct() {
            parent::__construct();
        }
        
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * CustwaList constructor with WidgetAreaList as parameter
         * 
         * @param WidgetAreaList $wa_list
         *      a widget area object to be copied to the new custom widget area  list
         * @return CustwaList a CustwaList containing the elements of the WidgetAreaList
         */
        public static function makeCustwaListWithWidgetAreaList($wa_list) {
            $new_custwa_list = new CustwaList();
            $new_custwa_list->set_wa_list($wa_list->get_wa_list());
            return $new_custwa_list;
        }
        
//-------------------------------------------------getters-------------------------------------------------

//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------  

//-------------------------------------------------end setters-------------------------------------
 
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * creates a DefwaList based on sidebars registered in a standard fashion
         * @param mixed $standard_registered_sidebars 
         *      the standard registered sidebars (eg. the global $wp_registered_sidebars)
         * @return DefwaList 
         *      a list of WidgetArea objects which is equivalent to $standard_registered_sidebars
         *      NULL - in case user has no privileges to use this function
         */
        static function standard_registered_sidebars_to_wa_list($standard_registered_sidebars, $curr_theme) {
                // create an empty list
                $new_list = new CustwaList();
                
                // for each standard registered sidebars
                foreach ($standard_registered_sidebars as $standard_sidebar) {
                    // create a new WidgetAreaPw object
                    $new_custwa = new Custwa(
                            $standard_sidebar['id'], 
                            $standard_sidebar['name'], 
                            $standard_sidebar['description'], 
                            $curr_theme, 
                            $standard_sidebar['class'], 
                            $standard_sidebar['before_widget'], 
                            $standard_sidebar['after_widget'], 
                            $standard_sidebar['before_title'], 
                            $standard_sidebar['after_title']
                            );
                    // add the created object to the list
                    $new_list->add($new_custwa);
                }

                // retrun the list of type WidgetAreaList
                return $new_list;
            return NULL;
        } // end function standard_registered_sidebars_to_wa_list
        
        
    }   // end CustwaList class
}   // end CustwaList not exist

?>
