<?php

require_once('WidgetAreaPw.php');
// if Defwa class does not exist
if(!class_exists('Defwa')){
    
    /**
     * Defwa represents a power widgets default widget area object
     *
     * @author Jonathan
     */
    class Defwa extends WidgetAreaPw{
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * Defwa Constructor - builds a new Defwa object
         * @param string $name
         *      defwa name
         * @param string $description
         *      defwa description
         * @param string $theme
         *      defwa theme
         * @param string $class
         *      defwa class
         * @param string $bewidget
         *      defwa before widget
         * @param string $afwidget Description
         *      defwa after widget
         * @param string $betitle
         *      defwa before title
         * @param string $aftitle
         *      defwa after title
         * 
         * @return Defwa
         * Defwa object - if defwa was successfully created.
         * Defwa object with all members set to NULL - if failed
         */
        public function __construct($id, $name, $description, $theme, $class = '', $bewidget = '', $afwidget= '', $betitle = '', $aftitle = '') {
            // Precondition: name is valid
            parent::__construct($id, $name, $description, $theme, $class, $bewidget, $afwidget, $betitle, $aftitle);
        }
        
        /**
         * Defwa Constructor - builds a new Defwa object with a given widget area
         * @param WidgetAreaPw $wa
         * @return Defwa
         */
        public static function __constructWithWa ($wa) {
            parent::__construct(
                    $wa->get_id(), 
                    $wa->get_name(), 
                    $wa->get_description(), 
                    $wa->get_theme(), 
                    $wa->get_class(), 
                    $wa->get_bewidget(), 
                    $wa->get_afwidget(), 
                    $wa->get_betitle(), 
                    $wa->get_aftitle()
                );
        } // end function __constructWithWa
    }   // end class
}   // end if class not exist

?>
