<?php

require_once('WidgetAreaList.php');
if(!class_exists('DefwaList')){
    
    /**
     * DefwaList implements a list of Defwa objects
     *
     * @author Jonathan
     */
    class DefwaList extends WidgetAreaList{
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * DefwaList constructor - builds a new DefwaList object contain empty list of defwas
     * @Return DefwaList new empty DefwaList.
     */
        public function __construct() {
            parent::__construct();
        }
        
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * DefwaList constructor with WidgetAreaList as parameter 
         * 
         * @param WidgetAreaList $wa_list 
         *      a widget area object to be copied to the new custom widget area  list 
         * @return DefwaList a DefwaList containing the elements of the WidgetAreaList 
         *      
         */
        public static function makeDefwaListWithWidgetAreaList($wa_list) {
            $new_defwa_list = new DefwaList();
            $new_defwa_list->setList($wa_list->getList());
            return $new_defwa_list;
        }
        
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * creates a DefwaList based on sidebars registered in a standard fashion
         * @param mixed $standard_registered_sidebars 
         *      the standard registered sidebars (eg. the global $wp_registered_sidebars)
         * @return DefwaList 
         *      a list of WidgetArea objects which is equivalent to $standard_registered_sidebars
         *      NULL - in case user has no privileges to use this function
         */
        static function standard_registered_sidebars_to_wa_list($standard_registered_sidebars, $curr_theme) {
                // create an empty list
                $new_list = new DefwaList();
                
                // for each standard registered sidebars
                foreach ($standard_registered_sidebars as $standard_sidebar) {
                    // create a new WidgetAreaPw object
                    $new_defwa = new Defwa(
                            $standard_sidebar['id'], 
                            $standard_sidebar['name'], 
                            $standard_sidebar['description'], 
                            $curr_theme, 
                            $standard_sidebar['class'], 
                            $standard_sidebar['before_widget'], 
                            $standard_sidebar['after_widget'], 
                            $standard_sidebar['before_title'], 
                            $standard_sidebar['after_title']
                            );
                    // add the created object to the list
                    $new_list->add($new_defwa);
                }

                // retrun the list of type WidgetAreaList
                return $new_list;
            return NULL;
        } // end function standard_registered_sidebars_to_wa_list
        
//-------------------------------------------------getters-------------------------------------------------

//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------  

//-------------------------------------------------end setters-------------------------------------
        
    }   // end DefwaList class
}   // end DefwaList not exist

?>
