<?php

/**
 * WasAjaxHandler handles ajax requests regarding was management
 *
 * @author Jonathan
 */
class WasAjaxHandler {
        /**
         * Constructor of WasAjaxHandler 
         */
        public function __construct() {
            
            /* actions */
            // add new custwa
            add_action('wp_ajax_add_new_custwa',  array($this, 'handleAddNewCustwa'), 10);
            
            // delete custwa
            add_action('wp_ajax_delete_custwa',  array($this, 'handleDeleteCustwa'), 10);
            
            // edit custwa
            add_action('wp_ajax_edit_custwa',  array($this, 'handleEditCustwa'), 10);
                    
        } // end WaManager Constructor
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * handles a get table ajax request by generating the table gui component and echoing it.
     * @param none
     * @return none
     */
    public function handleAddNewCustwa() {
        
        if (strcmp($_SERVER['REQUEST_METHOD'], "POST") == 0){
            //if the form that was sent was new cs form - update 
            if (isset($_POST['form_type']) && strcmp($_POST['form_type'], "newCS_form_type") == 0){
                //get custwa details
                $custwaName = wp_unslash($_POST['NewWaNameName']);  // name
                $custwaDescription = wp_unslash($_POST['NewWaDescriptionName']);    // description
                $custwaClass = '';                              /*wp_unslash ($_POST['NewWaClassName']);    // class name*/
                $custwaBeforeWidget = '';               /*wp_unslash ($_POST['NewWaBeforeWidgetName']); // before widgets*/
                $custwaAfterWidget = '';                /*wp_unslash ($_POST['NewWaAfterWidgetName']);   // after widgets*/
                $custwaBeforeTitle = '';                /*wp_unslash ($_POST['NewWaBeforeTitleName']);   // before title*/
                $custwaAfterTitle = '';                 /*wp_unslash ($_POST['NewWaAfterTitleName']);     // after title*/
                $custwaTheme = wp_get_theme();  // theme

                // try to add custwa
                $valid_custwa_insert = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->je_sb_add_custwa(
                        $custwaName, $custwaDescription, $custwaTheme, $custwaClass, $custwaBeforeWidget, $custwaAfterWidget, $custwaBeforeTitle, $custwaAfterTitle);
                // if successful
                if ($valid_custwa_insert){
                    /*
                    // add good notification
                    NotificationManager::je_sb_add_good_notification("New custom widget area was created!");
                     */
                    // redraw updated custwas table with added custwa
                    $this->redrawUpdatedCustwasTable();
                }
                // else if custwa input in invalid - it is taken care in the input validation function.
            }
        }
        
        // die because it's ajax req
        die();
    }
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * handles a get table ajax request by generating the table gui component and echoing it.
     * @param none
     * @return none
     */
    public function handleDeleteCustwa() {
        // get custwa to delete
        $custwaToDelete = $_POST['custwa'];
        $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->je_sb_delete_cs( $custwaToDelete );
        
        $this->redrawUpdatedCustwasTable();

        // die because it's ajax req
        die();
    }
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * handles edit table ajax request by generating the table gui component and echoing it.
     * @param none
     * @return none
     */
    public function handleEditCustwa() {
        if (strcmp($_SERVER['REQUEST_METHOD'], "POST") == 0){
            //if the form that was sent was new cs form - update 
            if (isset($_POST['form_type']) && strcmp($_POST['form_type'], "edit_wa_form_type") == 0){
                
                // get old custwa name
                $oldCustwaName = $_POST['oldCustwaName'];
                
                //get custwa details
                $custwaName = stripslashes ($_POST['NewWaNameName']);  // name
                $custwaDescription = stripslashes ($_POST['NewWaDescriptionName']);    // description
                $custwaClass = '';  /*stripslashes ($_POST['NewWaClassName']);    // class name*/
                $custwaBeforeWidget = '';   /*stripslashes ($_POST['NewWaBeforeWidgetName']);*/
                $custwaAfterWidget = '';    /*stripslashes ($_POST['NewWaAfterWidgetName']);*/
                $custwaBeforeTitle = '';    /*stripslashes ($_POST['NewWaBeforeTitleName']);*/
                $custwaAfterTitle = '';     /*stripslashes ($_POST['NewWaAfterTitleName']);*/
                $custwaTheme = wp_get_theme();  // theme

                // build edited custwa
                $editedCustwa = new Custwa($custwaName, $custwaName, $custwaDescription, $custwaTheme, 
                        $custwaClass, $custwaBeforeWidget, $custwaAfterWidget, $custwaBeforeTitle, $custwaAfterTitle);
                
                // edit custwa
                $validCustwaEdit = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->editCustwa($oldCustwaName, $editedCustwa);
                
                // if successful
                if ($validCustwaEdit) {
                    
                    // redraw updated custwas table with added custwa
                    $this->redrawUpdatedCustwasTable();
                }
                // else if custwa input in invalid - it is taken care in the input validation function.
            }
        }   // end check form was sent
        
        // die because it's ajax req
        die();
    }   // end function handleEditCustwa
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * get custwas from db and redraw updated custwas table with those custwas
     * @param none
     * @return void
     */
    private function redrawUpdatedCustwasTable () {
        
        //get updated custwas from db (including the new record)
        $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->set_custwas(
                $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_custwa_list_from_db()
        );
        
        // get the updated table server response
        $custwas = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_custwas();
        $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_wasGuiManager()->drawCustwas($custwas);
    }
}

?>
