<?php

// if class name not already exist
if(!class_exists('WasDbFunctionsLite')){
    /**
     * WasDbFunctionsLite contains a set of static db functions for widget areas management
     *
     * @author Jonathan
     */
    class WasDbFunctionsLite {
        
/*--------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * gets defwas from db
         * @global type $wpdb
         * @param string $defwaTableType
         * @return array
         *      array containing all defwas records
         */
        static function getDefwas($defwaTableType = 'default_wa'){
                global $wpdb;

                $query = "SELECT * FROM " . $wpdb->prefix . $defwaTableType . " ORDER BY defwa_id";

                return $wpdb->get_results($query, ARRAY_A);
        }
        
        
/*--------------------------------------------------------------------------------------------------------------------------------------*/
        /*
         * update defwas in db
         */
        static function updateDefwasInDb($defwas, $old = FALSE){
                global $wpdb;

                if ($old ) { $defwasTableType = 'old_default_wa' ;}
                else {$defwasTableType = 'default_wa'; }

                //remove all defwas
                DbFunctionsLite::deleteDefwas($defwasTableType);

                // fill defwa table with current theme data
                foreach ($defwas->getList() as $defwa) {
                    $defwa_id = $defwa->get_id();
                    $defwa_name = $defwa->get_name();
                    $defwa_theme = $defwa->get_theme();
                    $defwa_description = $defwa->get_description();
                    $defwa_class= $defwa->get_class();
                    $defwa_before_widget = $defwa->get_bewidget();
                    $defwa_after_widget = $defwa->get_afwidget();
                    $defwa_before_title = $defwa->get_betitle();
                    $defwa_after_title = $defwa->get_aftitle();

                    $query = 
                                "INSERT IGNORE INTO `" .$wpdb->prefix . $defwasTableType . "` (`defwa_id`, `defwa_theme`, `defwa_name`, `defwa_description`, `defwa_class`, `defwa_before_widget`, `defwa_after_widget`, `defwa_before_title`, `defwa_after_title`) 
                                    VALUES(%s, %s, %s, %s, %s, %s, %s, %s, %s)";
                    $wpdb->query(
                            $wpdb->prepare( 
                                    $query,
                                    $defwa_id,
                                    $defwa_theme,
                                    $defwa_name,
                                    $defwa_description,
                                    $defwa_class,
                                    $defwa_before_widget,
                                    $defwa_after_widget,
                                    $defwa_before_title,
                                    $defwa_after_title
                            ) 
                    );
                }

        }   // end function update_defwas_in_db
    }
}
?>
