<?php

if(!class_exists('WasScriptManager')) {
    /**
     * WasScriptManager is in charge of script handling and provides the following services:
     *  (1) manage widget areas scripts/styles registration
     *  (2) different functions enqueuing manage widget areas scripts/styles regarding a required page
     *
     * @author Jonathan
     */

    class WasScriptManager {
        
        /**
         * constructor of WasScriptManager
         * @param none
         * @return WasScriptManager
         */
        public function __construct() {
            // add theme importer stylesheet and js scripts
            add_action( 'admin_init', array($this, 'registerWasScripts') );
        }
        
        /**
         * function registers manage widget areas js scripts and css stylesheets
         * @param none
         * @return void
         */
        public function registerWasScripts () {
            // get plugin version
            $plugin_version = PowerWidgets::getPwPluginVersion();
            
            // css
            wp_register_style( 'was_css', pw_was_url . '/css/was_style.css', array(), $plugin_version);

            // js
            wp_register_script ('was-script', pw_was_url . '/js/was.js', array(  ), $plugin_version);
        }   // end function register_ti_scripts
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enques registered css style files to the "Theme Importer" submenu
         * @param none
         * @return void
         */
         function addWasStyle() {
                 wp_enqueue_style('was_css');
         }  // end function addWasStyle
         
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * enques registered js script files to the "Theme Importer" submenu
         * @param none
         * @return void
         */
         function addWasScripts() {
                 wp_enqueue_script ('was-script');
         }  // end function addWasScripts
    }
}
?>
