<?php


if(!class_exists('WidgetAreaList')){
    
    /**
     * WidgetAreaList implements a list of WidgetArea object using an array
     *
     * @author Jonathan
     */
    class WidgetAreaList extends PwListOfUnique{
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * WidgetAreaList constructor - builds a new WidgetAreaList object contain empty list of WidgetAreaPw
     * @Return WidgetAreaList new empty WidgetAreaList.
     */
        public function __construct() {
            parent::__construct();
        }
        
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * creates a WidgetAreaList based on sidebars registered in a standard fashion
         * @param mixed $standard_registered_sidebars 
         *      the standard registered sidebars (eg. the global $wp_registered_sidebars)
         * @return WidgetAreaList
         *      a list of WidgetArea objects which is equivalent to $standard_registered_sidebars
         *      NULL - in case user has no privileges to use this function
         */
        static function standard_registered_sidebars_to_wa_list($standard_registered_sidebars, $curr_theme) {
                // create an empty list
                $new_list = new WidgetAreaList();
                
                // for each standard registered sidebars
                foreach ($standard_registered_sidebars as $standard_sidebar) {
                    // create a new WidgetAreaPw object
                    $new_wa = new WidgetAreaPw(
                            $standard_sidebar['id'], 
                            $standard_sidebar['name'], 
                            $standard_sidebar['description'], 
                            $curr_theme, 
                            $standard_sidebar['class'], 
                            $standard_sidebar['before_widget'], 
                            $standard_sidebar['after_widget'], 
                            $standard_sidebar['before_title'], 
                            $standard_sidebar['after_title']
                            );
                    // add the created object to the list
                    $new_list->add($new_wa);
                }

                // retrun the list of type WidgetAreaList
                return $new_list;
        }
        
    }   // end WidgetAreaList class
}   // end WidgetAreaList not exist

?>
