<?php

// if WidgetAreaPw class does not exist
if(!class_exists('WidgetAreaPw')){

    /**
     * WidgetAreaPw represents a power widgets widget area object
     *
     * @author Jonathan
     */
    class WidgetAreaPw {
        private $id;
        private $name;
        private $description;
        private $theme;
        private $class;
        private $bewidget;
        private $afwidget;
        private $betitle;
        private $aftitle;
        
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
        /**
         * WidgetAreaPw Constructor - builds a new WidgetAreaPw object
         * @param string $id
         *      widget area id
         * @param string $name
         *      widget area name
         * @param string $description
         *      widget area description
         * @param string $theme
         *      widget area theme
         * @param string $class
         *      widget area class
         * @param string $bewidget
         *      widget area before widget
         * @param string $afwidget Description
         *      widget area after widget
         * @param string $betitle
         *      widget area before title
         * @param string $aftitle
         *      widget area after title
         * 
         * @return Defwa
         * Defwa object - if widget area was successfully created.
         * Defwa object with all members set to NULL - if failed
         */
        public function __construct($id, $name, $description, $theme, $class = '', $bewidget = '', $afwidget= '', $betitle = '', $aftitle = '') {

            // Precondition: wa name is valid
                $this->id = $id;
                $this->name = $name;
                $this->description = $description;
                $this->theme = $theme;
                $this->class = $class;
                $this->bewidget = $bewidget;
                $this->afwidget = $afwidget;
                $this->betitle = $betitle;
                $this->aftitle = $aftitle;
        }
        
//-------------------------------------------------getters-------------------------------------------------
    
        function get_id(){
            return $this->id;
        }
        
        function get_name(){
            return $this->name;
        }
        
        function get_description(){
            return $this->description;
        }
        
        function get_theme(){
            return $this->theme;
        }
        
        function get_class(){
            return $this->class;
        }
        
        function get_bewidget(){
            return $this->bewidget;
        }
        
        function get_afwidget(){
            return $this->afwidget;
        }
        
        function get_betitle(){
            return $this->betitle;
        }
        
        function get_aftitle(){
            return $this->aftitle;
        }
    
//-------------------------------------------------end getters-------------------------------------------------    
//-------------------------------------------------setters-------------------------------------------------  
    
        function set_id($value) {
            $this->id = $value;
        }
        
        function set_name($value) {
            $this->name = $value;
        }
        
        function set_description($value) {
            $this->description = $value;
        }
        
        function set_theme($value) {
            $this->theme = $value;
        }
        
        function set_class($value) {
            $this->class = $value;
        }
        
        function set_bewidget($value) {
            $this->bewidget = $value;
        }
        
        function set_afwidget($value) {
            $this->afwidget = $value;
        }
        
        function set_betitle($value) {
            $this->betitle = $value;
        }
    
        function set_aftitle($value) {
            $this->aftitle = $value;
        }
//-------------------------------------------------end setters-------------------------------------
            
    }  // end class WidgetAreaPw
}   // end if class exists

?>
