<?php

/**
 * WasGuiManager includes all gui components used for the repwas feature
 * and an output function for printing a replacements control interface
 *
 * @author Jonathan
 */
class WasGuiManager extends GuiManager{
    /*
     * TODO implement new interface
     */
/* -----------------------------------------------------------Manage Widget Areas----------------------------------------------------*/
    
    /**
     * Constructor of WasGuiManager
     * @param none
     * @return WasGuiManager
     */
    public function __construct() {
        parent::__construct();
        add_action('wp_ajax_generate_add_content',  array($this, 'generateAddContent'), 10);
        add_action('wp_ajax_generate_edit_content',  array($this, 'generateEditContent'), 10);
    }
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * outputs "Manage Widget Area" page content, including:
     *  (1) create new custwa form
     *  (2) delete existing custwa form
     * @param none
     * @return  void 
     */
    public function outputManageWa() {
            /*$this->je_sb_do_page_output('Manage Widget Areas');*/

            // get custwas
            $custwas = $GLOBALS['mainPwObj']->get_je_sb_wa_manager()->get_custwas();
?>
            <div id="admin-url" style="display:none"><?php echo admin_url();?></div>
            <div class="wrap">
<?php
                // make place for notifications
                $this->drawPlaceForNotifications();

                // draw title
                $this->drawTitle();

                // draw custwas
                $this->drawCustwas($custwas);
?>
            </div>
<?php
    }   // end function je_sb_output_newCS_content
       
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    private function drawPlaceForNotifications() {
?>
        <div id="was-notifications"></div>
<?php
    }
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    private function drawTitle() {
        $addLink = admin_url() . "admin-ajax.php?action=generate_add_content&TB_iframe=true&height=240&width=750";
?>

            <h2>
                <?php _e('Manage Custom Widget Areas', 'PWL'); ?>
                <a href="<?php echo $addLink ?>" class="button add-new-h2 thickbox">
                    <?php _e('Add New', 'PWL') ?>
                </a>
            </h2>
<?php
    }
    
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    public function drawCustwas($custwas) {
?>
        <div id="tablewrapper">
                <table class="widefat fixed" cellspacing="0">
                    <thead>
                        <tr>
                            <th style="width: 30%"><?php _e('Name', PWL); ?></th>
                            <th style="width: 54%"><?php _e ('Description', PWL); ?></th>
                            <th style="width: 8%"></th>
                            <th style="width: 8%"></th>
                        </tr>
                    </thead>
                    <tbody>
    <?php

                foreach ($custwas->getList() as $custwa) {

                    $id = $custwa->get_name() . "Id";
                    $id = str_replace ( " " , "_" , $id );  // replace spaces with '_'
                    $name = $custwa->get_name() . "Name";
                    $value = "";
                    // create edit button link
                    $editLink = admin_url() . "admin-ajax.php?action=generate_edit_content&custwaName=" . $custwa->get_name() . "&TB_iframe=true&height=240&width=750";
    ?>
                        <tr>
                            <td> <?php echo $custwa->get_name(); ?> </td>
                            <td><?php echo $custwa->get_description(); ?></td>
                            <td> <?php echo '<a href="' . $editLink .'" id="edit_pw_je_sb_' . $id . '" class="thickbox">'; _e('edit', PWL); echo '</a>'; ?> </td>
                            <td> <?php echo '<a href="#" id="delete_pw_je_sb_' . $id . '" >'; _e('delete', PWL); echo '</a>'; ?> </td>
                        </tr>

    <?php
                    }
    ?>
                    </tbody>
                </table>
        </div>

<?php
    }   // end function drawCustwas
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * generates add custwa content
     * @param none
     * @return void
     */
    public function generateAddContent( ) {
        // require add script
        require_once 'generate_add_custwa_content.php';

        // die because it's ajax req
        die();
    }   // end function generateAddContent
    
/* ---------------------------------------------------------------------------------------------------------------------------------------*/
    /**
     * generates edit custwa content
     * @param none
     * @return void
     */
    public function generateEditContent() {
        //require edit script
        require_once 'generate_edit_custwa_content.php';

        // die because it's ajax req
        die();
    }   // end function generateAddContent
    
}   // end class WasGuiManager

?>
