<?php 
// if uninstall not called from WordPress exit
if( !defined( 'WP_UNINSTALL_PLUGIN' ) ) 
    exit ();

global $wpdb;

/*
 * Defines
 */
// define these constants in case no other PW version exists
$pwLiteDir = __DIR__;
$pwLitePhp = $pwLiteDir . '/php';
$pwLiteClasses = $pwLitePhp . '/classes';

/*
 * Requires
 */
require_once ( $pwLiteClasses . '/DbFunctionsLite.php' );


// uninstall lite version data only if there is no pro version installed
$pWProVerData = NULL;
$pwProFilePath = dirname($pwLiteDir) . '/PowerWidgets/PowerWidgets.php';
if (file_exists($pwProFilePath)) {
    $pWProVerData = get_plugin_data( $pwProFilePath  );
}
if (  !$pWProVerData['Name']  ){

    // get all custwas
    $all_custwas = DbFunctionsLite::get_custwas();

    if ($all_custwas) {
        // Delete all custom custwa widgets
        foreach ($all_custwas as $custwa){
               // get sidebar widgets option from db
                $sidebar_widgets = get_option('sidebars_widgets', null);

                // get array of widgets of deleted custwa
                $deletedCustwaWidgets = $sidebar_widgets[$custwa['custwa_name']];

                // copy widgets of deleted custwa to inactive widgets
                if ($deletedCustwaWidgets) {
                    foreach ($deletedCustwaWidgets as $custwaWidget) {
                        $sidebar_widgets['wp_inactive_widgets'][] = $custwaWidget;
                    }
                }
                // delete deleted custwa's widgets
                unset($sidebar_widgets[$custwa['custwa_name']]);

                // update sidebars widgets option
                update_option('sidebars_widgets', $sidebar_widgets);
        }
    }

    // Delete all tables in the db
    $defwas_table = $wpdb->prefix."default_wa";
    $old_defwas_table = $wpdb->prefix."old_default_wa";
    $custwas_table = $wpdb->prefix."custom_wa";
    $reps_table = $wpdb->prefix."replacement_wa";
    $overriding_tax_table = $wpdb->prefix."overriding_prot_wa";
    $prototypes_table = $wpdb->prefix . "prototypes_wa";

    $wpdb->query("DROP TABLE IF EXISTS $defwas_table");
    $wpdb->query("DROP TABLE IF EXISTS $old_defwas_table");
    $wpdb->query("DROP TABLE IF EXISTS $custwas_table");
    $wpdb->query("DROP TABLE IF EXISTS $reps_table");
    $wpdb->query("DROP TABLE IF EXISTS $overriding_tax_table");
    $wpdb->query("DROP TABLE IF EXISTS $prototypes_table");

    // Delete pw_dir option
    delete_option('pw_dir');

    // Delete pw_blog_version option
    delete_option('pw_blog_version');

    // Delete old_theme option
    delete_option('pw_old_theme');
}

?>
